Our alerting solution is centered around two concepts: events and channels. The occurrence of an event can be configured to trigger an alert. A channel describes the delivery method for an alert. Every configured alert consists of an event type / channel pair. This level of granularity allows alerting to be configured to your exact preference.
Alerts (0.0.1)
https://api.mailgun.net/
https://api.eu.mailgun.net/
- US Mailgun
https://api.mailgun.net/v1/alerts/events
- EU Mailgun
https://api.eu.mailgun.net/v1/alerts/events
- curl
- JavaScript
- Node.js
- Python
- Java
- C#
- PHP
- Go
- Ruby
- R
- Payload
curl -i -X GET \
-u <username>:<password> \
https://api.mailgun.net/v1/alerts/events{ "events": [ "ip_listed", "ip_delisted" ] }
Request
Use this endpoint to add new alert settings record. This service facilitates notifications (Webhook, Slack, or Email) for both Mailgun Optimize and Send Alert threshold breaches.
This section covers details around consuming alerts via webhooks. If you are familiar with Mailgun Send webhooks (which provide status updates on individual email deliveries), there is a lot of overlapping similarity, however, there are also a few minor nuances to account for.
HMAC is used to verify the integrity as well as the authenticity of received webhooks. To verify the origin of a webhook:
- Encode the webhook’s entire POST request body with the HMAC algorithm (using your webhook signing key and SHA256 digest mode)
- Compare the resulting hexdigest to the signature provided in the POST request’s X-Sign header.
NOTE: If you’re consuming Mailgun Send webhooks, please note that your Mailgun Send webhook signing key differs from your Alerts webhook signing key. Your Alerts webhook signing keys, used for both Optimize and Send Alert products, are available within the Mailgun Alerts UI.
When adding or updating a webhook URL for alerts, we will ensure the endpoint is reachable by sending a GET request to the provided URL. If a 200 response is not returned from your endpoint, the request will be rejected and your alert setting will not be saved. We intentionally chose to send a GET request instead of a POST when validating URLs so that your webhook endpoint does not have to account for test requests.
Additionally, when a POST request is sent to your webhook URL, if a 2xx is not returned, we will attempt retries via an exponential backoff strategy for up to ~8 hours. If the max retry count is reached, the alert will be disabled and the related alert settings record’s disabled_at field will be populated.
The delivery method for the alert.
| Enum Value | Description |
|---|---|
| webhook | webhook |
| slack | Slack |
The details pertaining to the specified channel. Please note that the contents of this object differ per channel type.
- US Mailgun
https://api.mailgun.net/v1/alerts/settings/events
- EU Mailgun
https://api.eu.mailgun.net/v1/alerts/settings/events
- curl
- JavaScript
- Node.js
- Python
- Java
- C#
- PHP
- Go
- Ruby
- R
- Payload
curl -i -X POST \
-u <username>:<password> \
https://api.mailgun.net/v1/alerts/settings/events \
-H 'Content-Type: application/json' \
-d '{
"event_type": "ip_listed",
"channel": "webhook",
"settings": {
"url": "https://yourwebhookurl.com"
}
}'{ "id": "00000000-0000-0000-0000-000000000000", "event_type": "ip_listed", "channel": "webhook", "settings": { "url": "https://yourwebhookurl.com" } }
Request
Use this endpoint to update an existing alert setting record.
NOTE: When updating a webhook alert, we will ensure the endpoint is reachable by sending a GET request to the provided URL. If a 200 response is not returned, a 400 will be returned and the alert setting update will be rejected.
The delivery method for the alert.
| Enum Value | Description |
|---|---|
| webhook | webhook |
| slack | Slack |
The details pertaining to the specified channel. Please note that the contents of this object differ per channel type.
- US Mailgun
https://api.mailgun.net/v1/alerts/settings/events/{id}
- EU Mailgun
https://api.eu.mailgun.net/v1/alerts/settings/events/{id}
- curl
- JavaScript
- Node.js
- Python
- Java
- C#
- PHP
- Go
- Ruby
- R
- Payload
curl -i -X PUT \
-u <username>:<password> \
'https://api.mailgun.net/v1/alerts/settings/events/{id}' \
-H 'Content-Type: application/json' \
-d '{
"event_type": "ip_delisted",
"channel": "email",
"settings": {
"emails": [
"recipient-a@example.com",
"recipient-b@example.com"
]
}
}'{ "message": "settings updated" }